// Przykad do kodownia liczb w rnych systemach liczbowych by Iskar
// www.unit1.pl

unit Kod;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Button2: TButton;
    Label4: TLabel;
    Button3: TButton;
    Edit3: TEdit;
    Label5: TLabel;
    Edit4: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Edit5: TEdit;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    function DecNaDowolny(Liczba : Cardinal ; Podst : Integer) : String ;
    function DowolnyNaDec(Liczba : String ; Podst : Integer) : Cardinal ;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function TForm1.DowolnyNaDec(Liczba : String ; Podst : Integer) : Cardinal ;
var
  Dana : Integer ;
  i : Integer ;
begin
  Result := 0 ;
  
  if (Liczba = '') or (Podst < 2) or (Podst > 35) then Exit ;  // 1

  for i := 1 to Length(Liczba) do
  begin
    if Liczba[i] in ['A'..'Z'] then Dana := Ord(Liczba[i]) - Ord('A') + 10 // 2
    else Dana := StrToInt(Liczba[i]) ;
    
    if Dana >= Podst then // 3
    begin
      Result := 0 ;
      Exit ;
    end ;

    Result := Result + Dana * Trunc(Exp((Length(Liczba) - i) * Ln(Podst))) ; // 4
  end ;

  {
      Opis:

      1. Jeeli przesany cig znakw jest pusty lub podstawa systemu jest mniejsza od 2,
         to opuszczamy funkcj. Podst. systemu nie moe by te wiksza od 35, bo dla systemu
         o podst. = 36 zabrako by nam wielkich liter do reprezentacji kolejnych 'cyfr'.

      2. Jeeli podstawa systemu jest wiksza od 10, to do zapisu jej cyfr wikszych od 9 uywamy liter,
         musimy wic zamieni j na liczb. Obliczamy j, odejmujc od kodu danego znaku kod znaku A jako,
         e jest on pierwszy, a potem dodajemy 10, jako, e jest to nastpna 'cyfra' po 9. Np. B oznacza 11,
         wic od kodu tego znaku (66) odejmujemy kod pierwszego znaku, czyli A (65). Do wyniku dodajemy 10,
         gdy to tak warto ma pierwsza litera-A.

      3. Jeeli Dana jest wiksza bd rwna podst. systemu, to oznacza, e liczba jest le zapisana,
         poniewa w danym systemie moemy uywa jedynie cyfr z przedziau 0..Podstawa systemu -1.

      4. To najwaniejsza linijka.

          Exp((Length(Liczba) - i) * Ln(Podst)))

         stosujc: Exp(potega * Ln(liczba)) ; otrzymujemy dan potg podanej liczby. Musimy podnie
         podstaw systemu do potgi = pozycji cyfry w liczbie liczc od prawej. Stosujemy zapis
         Length(Liczba) - i aby otrzyma t pozycj. Mamy ju podniesion do odpowiedniej potgi
         podstaw systemu. Mnoymy j przez aktualn cyfr i wynik dodajemy do rezultatu zwracanego przez
         funkcj.
  }
end ;

function TForm1.DecNaDowolny(Liczba : Cardinal ; Podst : Integer) : String ;
var
  R : String ;
  Reszta : Integer ;
begin
  Result := '' ;
  if (Podst < 2) or (Podst > 35) or (Liczba <= 0) then Exit ;

  while Liczba <> 0 do
  begin
    Reszta := Liczba mod Podst ;  // 1
    if Reszta > 9 then R := Chr(Ord('A') - 10 + Reszta)  // 2
    else R := IntToStr(Reszta) ;
    Insert(R , Result , 1) ; // 3
    Liczba := Liczba div Podst ;  // 4
  end ;
  {
      Opis:

      1. Reszt z dzielenia zapisujemy w zmiennej.

      2. Jeeli reszta jest wiksza od zera, to oznacza, e mamy do czynienia z systemem
         o podstawie wikszej ni 10. Naley zatem zastapi dan cyfr znakiem,
         ktry bdzie oznacza dan cyfr.

      3. Wstawiamy na pocztek stringu - rezultatu reszt z dzielenia, ktr przed chwil wyliczylimy.
      
      4. Teraz przypisujemy Liczbie wynik dzielenia jej przez podstaw systemu.
  }
end ;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Label3.Caption := DecNaDowolny(StrToInt(Edit1.Text) , StrToInt(Edit2.Text)) ;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Label3.Caption := IntToStr(DowolnyNaDec(Edit1.Text , StrToInt(Edit2.Text))) ;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  Dec : Cardinal ;
begin
  Dec := DowolnyNaDec(Edit3.Text , StrToInt(Edit4.Text)) ;
  Label8.Caption := DecNaDowolny(Dec , StrToInt(Edit5.Text)) ;
end;

end.
